﻿-- Timeless Isle Daily Check
-- by Fluffies
-- EU-Well of Eternity
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local ldbicon = ldb and LibStub("LibDBIcon-1.0", true)
local TDCMainframe

local tdcicon = "Interface\\ICONS\\Spell_Nature_TimeStop"
local tx_optionsframe = "Interface\\icons\\Icon_PetFamily_Mechanical"
local tx_chkminimap   = "Interface\\icons\\INV_Misc_Map03"
local spacer = " - "
local ordos_name = EJ_GetEncounterInfo(861)
--local ordos_icon = "|TInterface\\EncounterJournal\\UI-EJ-BOSS-Ordos:20|t"
local celestials_name = "<celestials>"
--local celestials_icon = "|TInterface\\Icons\\INV_CelestialSerpentMount:20|t"
--local chest_icon = "|TInterface\\Icons\\Trade_Archaeology_ChestofTinyGlassAnimals:12|t "
--local rare_icon = "|TInterface\\Icons\\Achievement_Boss_Archaedas:12|t "
local s_optionsmain = "Toggle minimap button"

-- string colors
local LIGHT_RED   = "|cffFF2020"
local LIGHT_GREEN = "|cff20FF20"
local LIGHT_BLUE  = "|cff00ddFF"
local ZONE_BLUE   = "|cff00aacc"
local GRAY        = "|cffBBBBBB"
local GOLD        = "|cffffcc00"
local WHITE       = "|cffffffff"
local PINK        = "|cffFFaaaa"
local function AddColor(str,color)
 return color..str.."|r"
end

local function completedstring(arg)
 if IsQuestFlaggedCompleted(arg) then
  return AddColor(COMPLETE,LIGHT_GREEN)
 else
  return AddColor(INCOMPLETE,LIGHT_RED)
 end
end

local function DrawMainframe(frame, istooltip)
-- title
 frame:ClearLines()
 frame:AddDoubleLine("Timeless Isle Daily Check","|T"..tdcicon..":32|t")
 frame:AddLine(" ")
 frame:AddLine(" ")

 frame:AddDoubleLine(AddColor("<Weekly> ",LIGHT_BLUE)..AddColor("[BOSS]",GOLD)..AddColor(ordos_name,GRAY), completedstring(33118)) -- Ordos
 frame:AddDoubleLine(AddColor("<Weekly> ",LIGHT_BLUE)..AddColor("[BOSS]",GOLD)..AddColor(celestials_name,GRAY), completedstring(33117)) -- Celestials
 frame:AddDoubleLine(AddColor("<Weekly> ",LIGHT_BLUE)..AddColor("[BATTLE PETS]",GOLD)..AddColor(select(2,GetAchievementInfo(8410)),GRAY), completedstring(33137)) -- Celestial Pet Tournament
 frame:AddDoubleLine(AddColor("<Weekly> ",LIGHT_BLUE)..AddColor("Spectral Pirate Treasure",GRAY)..AddColor(" (Coords 17, 58)",WHITE), completedstring(32956)) -- Spectral Pirate Treasure
 frame:AddDoubleLine(AddColor("<Weekly> ",LIGHT_BLUE)..AddColor("50 Epoch Stones",GRAY), completedstring(33338))  -- 50 Epoch Stones
 frame:AddDoubleLine(AddColor("<Weekly> ",LIGHT_BLUE)..AddColor("5 Rares Vanquished",GRAY), completedstring(33334))  -- 5 Rares Vanquished
 frame:AddLine(" ")
 frame:AddDoubleLine(AddColor("<Daily>  ",LIGHT_BLUE)..AddColor("20 Elites Vanquished",GRAY), completedstring(33374))  -- 20 Elites Vanquished
 frame:AddDoubleLine(AddColor("<Daily>  ",LIGHT_BLUE)..AddColor("A Timeless Question",GRAY), completedstring(33211))  -- A Timeless Question
 -- I'm not releasing these until I find out what they track
 --frame:AddDoubleLine(AddColor("<Daily>  ",LIGHT_BLUE)..AddColor("Guru Kukuru?",GRAY), completedstring(32949))  -- Guru Kukuru
 --frame:AddDoubleLine(AddColor("<Daily>  ",LIGHT_BLUE)..AddColor("Ghost Pirate Battle",GRAY), completedstring(32964))  -- Ghost Pirate battle: Completed
 --frame:AddDoubleLine(AddColor("<Daily>  ",LIGHT_BLUE)..AddColor("Ghost Pirate Battle, Treasure Looted",GRAY), completedstring(32965))  -- Ghost Pirate battle: Treasure Looted
 frame:AddLine(" ")
 if not istooltip then
  frame:AddLine(" ")
  frame:AddLine(" ")
  --frame:AddLine(" ")
 end
end

local tidcchatheader = AddColor("Timeless Isle Daily Check: ",LIGHT_BLUE)
local chatseparator = " - "

local function CreateMainframe(arg)

 if arg == "print" then
  print("--- "..tidcchatheader.."---")
  print(AddColor("<Weekly> ",LIGHT_BLUE)..AddColor("[BOSS]",GOLD)..AddColor(ordos_name,GRAY), completedstring(33118)) -- Ordos
  print(AddColor("<Weekly> ",LIGHT_BLUE)..AddColor("[BOSS]",GOLD)..AddColor(celestials_name,GRAY), completedstring(33117)) -- Celestials
  print(AddColor("<Weekly> ",LIGHT_BLUE)..AddColor("[BATTLE PETS]",GOLD)..AddColor(select(2,GetAchievementInfo(8410)),GRAY), completedstring(33137)) -- Celestial Pet Tournament
  print(AddColor("<Weekly> ",LIGHT_BLUE)..AddColor("Spectral Pirate Treasure",GRAY)..AddColor(" (Coords 17, 58)",WHITE), completedstring(32956)) -- Spectral Pirate Treasure
  print(AddColor("<Weekly> ",LIGHT_BLUE)..AddColor("50 Epoch Stones",GRAY), completedstring(33338))  -- 50 Epoch Stones
  print(AddColor("<Weekly> ",LIGHT_BLUE)..AddColor("5 Rares Vanquished",GRAY), completedstring(33334))  -- 5 Rares Vanquished
  print(AddColor("<Daily>  ",LIGHT_BLUE)..AddColor("20 Elites Vanquished",GRAY), completedstring(33374))  -- 20 Elites Vanquished
  print(AddColor("<Daily>  ",LIGHT_BLUE)..AddColor("A Timeless Question",GRAY), completedstring(33211))  -- A Timeless Question
  print("---------")
  return
 end

 if TDCMainframe and TDCMainframe:IsVisible() then
  TDCMainframe:Hide()
 else
  if not TDCMainframe then
   TDCMainframe = CreateFrame("GameTooltip", "TDCMainframe", nil, "GameTooltipTemplate")
  end
  
  TDCMainframe:SetOwner(UIParent,"ANCHOR_NONE")
  TDCMainframe:SetPoint("CENTER",UIParent,"CENTER")
  TDCMainframe:SetFrameStrata("HIGH")
  TDCMainframe:EnableMouse(true)
  TDCMainframe:SetMovable()
  TDCMainframe:SetScale(0.9)
  TDCMainframe:RegisterForDrag("LeftButton")
  TDCMainframe:SetScript("OnDragStart", function(self)  
		self:StartMoving()
  end)
  TDCMainframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing()
  end)
  
  DrawMainframe(TDCMainframe)

-- Hide minimap button
   if not TDCMainframe.optionsframe then
    TDCMainframe.optionsframe = CreateFrame("FRAME", nil, TDCMainframe)
    TDCMainframe.optionsframe.texture = TDCMainframe.optionsframe:CreateTexture()
    TDCMainframe.optionsframe:SetPoint("BOTTOMLEFT",TDCMainframe,"BOTTOMLEFT",10,10)
    TDCMainframe.optionsframe:SetWidth(25)
    TDCMainframe.optionsframe:SetHeight(25)
    TDCMainframe.optionsframe.texture:SetPoint("CENTER",TDCMainframe.optionsframe,"CENTER")
    TDCMainframe.optionsframe.texture:SetAllPoints()
    TDCMainframe.optionsframe.texture:SetTexture(tx_chkminimap)
    TDCMainframe.optionsframe:SetScript("OnLeave", function(self)
     GameTooltip:Hide()
    end)
    TDCMainframe.optionsframe:SetScript("OnEnter", function(self)
     GameTooltip:SetOwner(TDCMainframe.optionsframe,"ANCHOR_TOP",0,5)
     GameTooltip:ClearLines()
     GameTooltip:AddLine(s_optionsmain)
     GameTooltip:Show()
    end)

    TDCMainframe.optionsframe:SetScript("OnMouseUp", function(self)
     if not TDCMainframe.optionsframe.open then
      TimelessDailyCheck_Options["minimap_icon"].hide = false
      TDCMainframe.optionsframe.open = true
      TDCMainframe.optionsframe.texture:SetVertexColor(1,1,1,1)
     else
      TimelessDailyCheck_Options["minimap_icon"].hide = true
      TDCMainframe.optionsframe.open = false
      TDCMainframe.optionsframe.texture:SetVertexColor(0.5,0.5,0.5,1)
     end
     ldbicon:Refresh("TimelessDailyCheck", TimelessDailyCheck, TimelessDailyCheck_Options["minimap_icon"])
    end)
   end
   TDCMainframe.optionsframe.open = not TimelessDailyCheck_Options["minimap_icon"].hide
   if TDCMainframe.optionsframe.open then
    TDCMainframe.optionsframe.texture:SetVertexColor(1,1,1,1)
   else
    TDCMainframe.optionsframe.texture:SetVertexColor(0.5,0.5,0.5,1)    
   end
--
-- About
  if not TDCMainframe.Rabouttext then
   TDCMainframe.Rabouttext = TDCMainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
   TDCMainframe.Rabouttext:SetFont("Fonts\\FRIZQT__.TTF",8)
   TDCMainframe.Rabouttext:SetText(AddColor("                by",GRAY)..
                                   AddColor(" Fluffies\n",LIGHT_BLUE)..
                                   AddColor(" EU-Well of Eternity",GRAY))
   TDCMainframe.Rabouttext:SetPoint("BOTTOMRIGHT",TDCMainframe,"BOTTOMRIGHT",-5,5)
   TDCMainframe.Rabouttext:Show()
  end
--
-- Close button
  if not TDCMainframe.btnclose then
   TDCMainframe.btnclose = CreateFrame("Button", "tdcclosebtn", TDCMainframe, "UIPanelButtonTemplate")
   TDCMainframe.btnclose:SetPoint("BOTTOM", TDCMainframe, "BOTTOM",0,10)
   TDCMainframe.btnclose:SetWidth(100)
   TDCMainframe.btnclose:SetText(CLOSE)
   TDCMainframe.btnclose:SetScript("OnClick", function(self)
    TDCMainframe:Hide()
    collectgarbage()
   end)
 end
--
 TDCMainframe:Show()
end
end

local ldbset = false
local eventframe = CreateFrame("FRAME","TDCEventFrame")
eventframe:RegisterEvent("VARIABLES_LOADED")
eventframe:RegisterEvent("PLAYER_ENTERING_WORLD")
local function eventhandler(self, event, ...)
 if event == "PLAYER_ENTERING_WORLD" then
  celestials_name = select(2,GetAchievementInfo(8535))
  if celestials_name == nil then celestials_name = "Celestials" end
 elseif event == "VARIABLES_LOADED" then
  if TimelessDailyCheck_Options == nil then
   TimelessDailyCheck_Options = {}
  end
  if TimelessDailyCheck_Options["minimap_icon"] == nil then
    TimelessDailyCheck_Options["minimap_icon"] = {
        hide = false,
        minimapPos = 220,
    }
  end

  if ldb and not ldbset then
   local TimelessDailyCheck = ldb:NewDataObject("TimelessDailyCheck", {
	type = "data source",
	icon = tdcicon,
	label = "Timeless Daily Check",
	OnClick = function(self,button)
         CreateMainframe()
	end,
	OnTooltipShow = function(tooltip)
		 DrawMainframe(tooltip,true)
	end,
   })
   if ldbicon then
    ldbicon:Register("TimelessDailyCheck", TimelessDailyCheck, TimelessDailyCheck_Options["minimap_icon"])
   end
   ldbset = true
  end -- variables_loaded
 end
end
eventframe:SetScript("OnEvent", eventhandler);

-- slash command
SLASH_TIMELESSDAILYCHECK1 = "/tidc"
SLASH_TIMELESSDAILYCHECK2 = "/tdc"
SlashCmdList["TIMELESSDAILYCHECK"] = CreateMainframe